Imports Microsoft.VisualBasic
Imports System
Imports System.Web.UI
Imports System.Workflow.Runtime
Imports WorkflowCore
Imports WorkflowCore.Logging
Imports WorkflowCore.Data

'////////////////////////////////////////////////////////////////////
' Created by Michael Kennedy
' http://www.michaelckennedy.net
' Copyright Michael Kennedy 2008.
' Part of the HRWorkflow sample application featured in MSDN Magazine.
'

Namespace HRWorkflow
	Partial Public Class AssignJob
		Inherits Page
		Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
			If (Not IsPostBack) Then
				Dim employee As Employee = Database.FindEmployee(QueryStringData.GetWorkflowId())
				LabelPerson.Text = employee.Name & " (age " & employee.Age & ")"

				TraceDT.Add("Page loaded, pulling employee from 'db'.", QueryStringData.GetWorkflowId(), Me.GetType())
			End If
		End Sub

		Protected Sub ButtonSubmit_Click(ByVal sender As Object, ByVal e As EventArgs)
			Dim id As Guid = QueryStringData.GetWorkflowId()
            Dim wfInst As WorkflowInstance = [Global].WorkflowRuntime.GetWorkflow(id)

			Dim job As New Job()
			job.JobTitle = DropDownListJob.SelectedValue
			job.Salary = Convert.ToDouble(TextBoxSalary.Text)

			TraceDT.Add("Page processing assignment, pulling employee from 'db', proposed job {0}.", QueryStringData.GetWorkflowId(), Me.GetType(), job.JobTitle)

			wfInst.EnqueueItem(AssignJobActivity.QUEUE_NAME, job, Nothing, Nothing)

			buttonSubmit.Enabled = False

            LabelMessage.Text = "<br /><br />Ok, now pretend you're the prospective employee who got an email saying" & _
                " there is a new recruit. Click <a href='ConfirmJob.aspx?id=" & id.ToString & "'>here</a>."
		End Sub
	End Class
End Namespace