Imports Microsoft.VisualBasic
Imports System
Imports System.Workflow.Runtime
Imports WorkflowCore
Imports WorkflowCore.Logging
Imports WorkflowCore.Data

'////////////////////////////////////////////////////////////////////
' Created by Michael Kennedy
' http://www.michaelckennedy.net
' Copyright Michael Kennedy 2008.
' Part of the HRWorkflow sample application featured in MSDN Magazine.
'

Namespace HRWorkflow
	Partial Public Class ConfirmJob
		Inherits System.Web.UI.Page
		Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
			If (Not IsPostBack) Then
				Dim employee As Employee = Database.FindEmployee(QueryStringData.GetWorkflowId())
				LabelPerson.Text = employee.Name
				LabelJob.Text = employee.Job
				LabelSalary.Text = employee.Salary.ToString("C0")

				TraceDT.Add("Page loading with employee: {0}.", QueryStringData.GetWorkflowId(), Me.GetType(), employee.Name)
			End If
		End Sub

		Protected Sub LinkButtonYes_Click(ByVal sender As Object, ByVal e As EventArgs)
			TraceDT.Add("Page processing employee response: {0}.", QueryStringData.GetWorkflowId(), Me.GetType(), "accepted")

			Dim id As Guid = QueryStringData.GetWorkflowId()
            Dim wfInst As WorkflowInstance = [Global].WorkflowRuntime.GetWorkflow(id)
			wfInst.EnqueueItem(ConfirmJobActivity.QUEUE_NAME, "Yes", Nothing, Nothing)

            Response.Redirect("Finished.aspx?id=" & id.ToString)
		End Sub

		Protected Sub LinkButtonNo_Click(ByVal sender As Object, ByVal e As EventArgs)
			TraceDT.Add("Page processing employee response: {0}.", QueryStringData.GetWorkflowId(), Me.GetType(), "decliened")

			Dim id As Guid = QueryStringData.GetWorkflowId()
            Dim wfInst As WorkflowInstance = [Global].WorkflowRuntime.GetWorkflow(id)
			wfInst.EnqueueItem(ConfirmJobActivity.QUEUE_NAME, "No", Nothing, Nothing)

            Response.Redirect("Finished.aspx?id=" & id.ToString)
		End Sub
	End Class
End Namespace
