﻿Imports System.Workflow.Activities
Imports System.Workflow.ComponentModel
Imports WorkflowCore.Data
Imports WorkflowCore.Logging

Namespace WorkflowCore
    Partial Public Class AssignJobActivity
        Inherits AsyncActivity

        Public Const QUEUE_NAME As String = "AssignJobQueue"

        Public Sub New()
            MyBase.New(QUEUE_NAME)
            InitializeComponent()
        End Sub

        Protected Overrides Function Execute(ByVal ctx As ActivityExecutionContext) As ActivityExecutionStatus
            TraceDT.Add("Execution beginning, waiting on queue.", Me.WorkflowInstanceId, Me.GetType())

            SubscribeToItemAvailable(ctx)
            Return ActivityExecutionStatus.Executing
        End Function

        Protected Overrides Sub OnQueueItemAvailable(ByVal ctx As ActivityExecutionContext)
            Dim job As Job = CType(GetQueue(ctx).Dequeue(), Job)
            TraceDT.Add("Execution completing, queue item available: Assigned job {0} at {1}.", Me.WorkflowInstanceId, Me.GetType(), job.JobTitle, job.Salary)

            ' Assign job to employee, save in DB.
            Dim employee As Employee = Database.FindEmployee(Me.WorkflowInstanceId)
            employee.Job = job.JobTitle
            employee.Salary = job.Salary
        End Sub
    End Class
End Namespace
