﻿Imports System.Workflow.ComponentModel
Imports WorkflowCore.Data
Imports WorkflowCore.Logging

Namespace WorkflowCore
    Partial Public Class ConfirmJobActivity
        Inherits AsyncActivity
        Public Const QUEUE_NAME As String = "ConfirmJobQueue"

        Public Sub New()
            MyBase.New(QUEUE_NAME)
            InitializeComponent()
        End Sub

        Protected Overrides Function Execute(ByVal ctx As ActivityExecutionContext) As ActivityExecutionStatus
            TraceDT.Add("Execution beginning, waiting on queue.", Me.WorkflowInstanceId, Me.GetType())

            SubscribeToItemAvailable(ctx)
            Return ActivityExecutionStatus.Executing
        End Function

        Protected Overrides Sub OnQueueItemAvailable(ByVal ctx As ActivityExecutionContext)
            EmployeeResponse = GetQueue(ctx).Dequeue().ToString()

            Dim employee As Employee = Database.FindEmployee(Me.WorkflowInstanceId)
            employee.Accepted = GetAcceptedStatus()

            TraceDT.Add("Execution completing, queue item available: Response: {0}.", Me.WorkflowInstanceId, Me.GetType(), EmployeeResponse)
        End Sub

        Private Function GetAcceptedStatus() As Boolean
            Return Boolean.Parse(EmployeeResponse.ToLower().Replace("yes", "true").Replace("no", "false"))
        End Function

#Region "DependencyProperty: public string EmployeeResponse"

        Public Shared EmployeeResponseProperty As DependencyProperty = DependencyProperty.Register("EmployeeResponse", GetType(String), GetType(ConfirmJobActivity))

        Public Property EmployeeResponse() As String
            Get
                Return (CStr(MyBase.GetValue(EmployeeResponseProperty)))
            End Get
            Set(ByVal value As String)
                MyBase.SetValue(EmployeeResponseProperty, value)
            End Set
        End Property
#End Region
    End Class
End Namespace

