﻿Imports System.Workflow.Activities
Imports System.Workflow.ComponentModel
Imports WorkflowCore.Data
Imports WorkflowCore.Logging

Namespace WorkflowCore
    Partial Public Class GatherEmployeeInfoActivity
        Inherits AsyncActivity

        Public Const QUEUE_NAME As String = "GatherInfoQueue"

        Private privateEmployee As Employee
        Public Property Employee() As Employee
            Get
                Return privateEmployee
            End Get
            Set(ByVal value As Employee)
                privateEmployee = value
            End Set
        End Property

        Public Sub New()
            MyBase.New(QUEUE_NAME)
            InitializeComponent()
        End Sub

        Protected Overrides Function Execute(ByVal ctx As ActivityExecutionContext) As ActivityExecutionStatus
            TraceDT.Add("Execution beginning, waiting on queue.", Me.WorkflowInstanceId, Me.GetType())

            SubscribeToItemAvailable(ctx)
            Return ActivityExecutionStatus.Executing
        End Function

        Protected Overrides Sub OnQueueItemAvailable(ByVal ctx As ActivityExecutionContext)
            Dim employee As Employee = CType(GetQueue(ctx).Dequeue(), Employee)

            TraceDT.Add("Execution completing, queue item available: New prospect: {0}.", Me.WorkflowInstanceId, Me.GetType(), employee.Name)

            ' Store data in DB
            Database.SaveEmployee(Me.WorkflowInstanceId, employee)
        End Sub
    End Class
End Namespace