Imports Microsoft.VisualBasic
Imports System
Imports System.Linq
Imports System.Collections.Generic

'////////////////////////////////////////////////////////////////////
' Created by Michael Kennedy
' http://www.michaelckennedy.net
' Copyright Michael Kennedy 2008.
' Part of the HRWorkflow sample application featured in MSDN Magazine.
'

Namespace WorkflowCore.Logging
	Public Class TraceDT
		Public Shared Sub Add(ByVal text As String, ByVal wfID As Guid, ByVal source As Type, ParamArray ByVal args() As Object)
			Dim message As String = String.Format("{0} - {1}: {2}", DateTime.Now, source.Name, String.Format(text, args))

			Dim entry As New TraceEntry(message)

			Dim list As List(Of TraceEntry)
			If wfID = Guid.Empty Then
				list = GlobalMessageList
			Else
				list = GetSessionMessageList(wfID)
			End If

			list.Add(entry)
		End Sub

		Private Shared GlobalMessageList As List(Of TraceEntry) = New List(Of TraceEntry)()

		Private Shared WfSpecificMessageList As Dictionary(Of Guid, List(Of TraceEntry)) = New Dictionary(Of Guid, List(Of TraceEntry))()

		Public Shared Function GetMessages(ByVal newestFirst As Boolean, ByVal wfId As Guid) As String()
			SyncLock GlobalMessageList
				Dim messages = _
					From entry In GlobalMessageList.Union(GetSessionMessageList(wfId)) _
					Order By entry.Created _
					Select entry.Message

				If newestFirst Then
					Return messages.Reverse().ToArray()
				Else
					Return messages.ToArray()
				End If
			End SyncLock
		End Function

		Private Shared Function GetSessionMessageList(ByVal wfId As Guid) As List(Of TraceEntry)
			If wfId = Guid.Empty Then
				Return New List(Of TraceEntry)()
			End If

			If WfSpecificMessageList.ContainsKey(wfId) Then
				Return WfSpecificMessageList(wfId)
			End If

			WfSpecificMessageList(wfId) = New List(Of TraceEntry)()

			Return WfSpecificMessageList(wfId)
		End Function
	End Class
End Namespace
